#!/bin/sh

# Travis-CI Build Script for AlphaChat/ACOPM
# See https://travis-ci.org/ for details

set -e
set -x

CONFIGURE_ARGUMENTS="--disable-debug"

if test "x${TRAVIS_MBEDTLS}" = "xyes"
then
	CONFIGURE_ARGUMENTS="${CONFIGURE_ARGUMENTS} --with-mbedtls=internal"
else
	CONFIGURE_ARGUMENTS="${CONFIGURE_ARGUMENTS} --without-mbedtls"
fi

./autogen.sh
./configure ${CONFIGURE_ARGUMENTS}

if test "x${TRAVIS_MBEDTLS}" = "xyes"
then
	## https://github.com/ARMmbed/mbedtls/issues/1001
	grep -q -- '#include MBEDTLS_CONFIG_FILE' mbedtls/include/mbedtls/md.h || \
	    patch -d mbedtls/include/mbedtls < .travis/mbedtls-issue-1001.patch
fi

make -s
make -s check
make -s install
make -s distclean
./antigen.sh

set +x

echo ""
echo "Built Successfully"
echo ""
