/*
 * Copyright (C) 2017 Aaron M. D. Jones <aaronmdjones@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following
 * conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED.
 *
 * IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef INC_LIBACOPM_DNSBL_DOMAIN_H
#define INC_LIBACOPM_DNSBL_DOMAIN_H

#include "acopm-common.h"

struct acopm_dnsbl_client;
struct acopm_dnsbl_domain;

enum acopm_dnsbl_aftype
{
	ACOPM_DNSBL_AFTYPE_IPV4 = 0x01,
	ACOPM_DNSBL_AFTYPE_IPV6 = 0x02,
	ACOPM_DNSBL_AFTYPE_BOTH = 0x03,
} acopm_attr_packed;

struct acopm_dnsbl_domain *acopm_dnsbl_domain_new(struct acopm_dnsbl_client *) acopm_attr_malloc;
void acopm_dnsbl_domain_set_type(struct acopm_dnsbl_domain *, enum acopm_dnsbl_aftype);
void acopm_dnsbl_domain_set_host(struct acopm_dnsbl_domain *, const char *);
bool acopm_dnsbl_domain_add(struct acopm_dnsbl_domain *);
void acopm_dnsbl_domain_free(struct acopm_dnsbl_domain *);

#endif /* !INC_LIBACOPM_DNSBL_DOMAIN_H */
