/*
 * Copyright (C) 2017 Aaron M. D. Jones <aaronmdjones@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following
 * conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED.
 *
 * IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef INC_LIBACOPM_PROXY_SOCKS4_H
#define INC_LIBACOPM_PROXY_SOCKS4_H

#include "acopm-common.h"

#define ACOPM_SOCKS4_VERSION                    0x04

#define ACOPM_SOCKS4_CMD_CONNECT                0x01
#define ACOPM_SOCKS4_CMD_LISTEN                 0x02

#define ACOPM_SOCKS4_REQ_GRANTED                0x5A
#define ACOPM_SOCKS4_REQ_REJECTED               0x5B
#define ACOPM_SOCKS4_REQ_FAILED_IDENT_UNREACH   0x5C
#define ACOPM_SOCKS4_REQ_FAILED_IDENT_MISMATCH  0x5D

struct acopm_socks4_request
{
	uint8_t     version;
	uint8_t     command;
	uint16_t    port;
	uint32_t    addr;
} acopm_attr_packed;

struct acopm_socks4_response
{
	uint8_t     null;
	uint8_t     status;
	uint16_t    port;
	uint32_t    addr;
} acopm_attr_packed;

#endif /* !INC_LIBACOPM_PROXY_SOCKS4_H */
