/*
 * Copyright (C) 2017 Aaron M. D. Jones <aaronmdjones@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following
 * conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED.
 *
 * IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#include "acopm-common.h"

#include <event2/event.h> /* struct event_base */

#include "vars.h" /* global variable definitions */

#include "irc/client.h" /* struct acopm_irc_client */
#include "dnsbl/client.h" /* struct acopm_dnsbl_client */
#include "proxy/client.h" /* struct acopm_proxy_client */

struct event_base *ev_base = NULL;

struct acopm_irc_client *acopm_irc_client = NULL;
struct acopm_dnsbl_client *acopm_dnsbl_client = NULL;
struct acopm_proxy_client *acopm_proxy_client = NULL;

char config_file[PATH_MAX];
char proxy_hit_exe[PATH_MAX];
char proxy_hit_log[PATH_MAX];

char client_notice_msg[ACOPM_IRC_NOTICE_MAX + 1];
char dnsbl_hit_cmd[ACOPM_IRC_LINE_MAX + 1];
char proxy_hit_cmd[ACOPM_IRC_LINE_MAX + 1];
char proxy_hit_var1[ACOPM_EXE_CONF_MAX + 1];
char proxy_hit_var2[ACOPM_EXE_CONF_MAX + 1];
char proxy_hit_var3[ACOPM_EXE_CONF_MAX + 1];
char proxy_hit_var4[ACOPM_EXE_CONF_MAX + 1];
char proxy_hit_var5[ACOPM_EXE_CONF_MAX + 1];
